﻿/*
 * finalproject.c
 *
 * Created: 2016/6/11 19:57:51
 *  Author: Jaymok
 *     LAB: FabLabXH
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

/*------define------*/
#define uchar	unsigned char
#define uint	unsigned int
#define lcd_RS_dat (PORTB |= 0x01) 
#define lcd_RS_comm (PORTB &= 0xFE)
#define lcd_RW_read (PORTB |= 0x02) 
#define lcd_RW_write (PORTB &= 0xFD) 
#define lcd_EN_write (PORTB &=0xFB)  
#define lcd_EN_read (PORTB |=0x04) 


#define NOP() asm("nop")
//port_init
void port_init(void)
{
 PORTB = 0x0F;
 DDRB  = 0xFF;
 PORTC = 0x0F;
 DDRC  = 0x7F;
 PORTD = 0x00;
 DDRD  = 0xFF;
	
}


//write command to lcd
void lcd_write_comm(uchar comm)
{
	lcd_RS_comm;
	lcd_RW_write;
	lcd_EN_write;
	NOP();
	lcd_EN_read;
	PORTD = comm;
	lcd_EN_write;
}

//write data to lcd
void lcd_write_dat(uchar dat)
{
	lcd_RS_dat;
	lcd_RW_write;
	lcd_EN_write;
	NOP();
	lcd_EN_read;
	PORTD = dat;
	lcd_EN_write;
}


//init lcd
void init_lcd(void)
{
	lcd_EN_read;
	lcd_write_comm(0x38);
	_delay_ms(1);
	lcd_write_comm(0x0c);
	_delay_ms(1);
	lcd_write_comm(0x06);
	_delay_ms(1);
	lcd_write_comm(0x01);
	_delay_ms(1);
	
}
//data;
const uchar txt[] ="Hello! Welcome! ";
const uchar txt2[] = "FabAcademy2016!";



int main(void)
{
	uchar i = 0;
	cli();
	port_init();
	MCUCR = 0x00;
	sei();
	init_lcd();
 //START INTERFACE  
    lcd_write_comm(0x80);
	for(i=0; i<15; i++)
	{
	  lcd_write_dat(txt[i]);
	  _delay_ms(200);		
	}
	lcd_write_comm(0xC0);
	for(i=0; i<15; i++)
	{
	  lcd_write_dat(txt2[i]);
	  _delay_ms(200);		
	}
	
}