﻿/*
 * slave.c
 *
 * Created: 2016/6/10 21:24:34
 *  Author: JayMok
 */ 

#include <avr/io.h>
#include <stdio.h>
#include <string.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <USART.h>

#define uchar	unsigned char
#define uint	unsigned int
#define lcd_RS_dat (PORTC |= 0x01) 
#define lcd_RS_comm (PORTC &= 0xFE)
#define lcd_RW_read (PORTC |= 0x02) 
#define lcd_RW_write (PORTC &= 0xFD) 
#define lcd_EN_write (PORTC &=0xFB)  
#define lcd_EN_read (PORTC |=0x04) 


#define NOP() asm("nop")
//port_init
void port_init(void)
{
 PORTB = 0x00;
 DDRB  = 0x00;
 PORTC = 0x00; //m103 output only
 DDRC  = 0x3F;
 PORTD = 0x00;
 DDRD  = 0x00;
	
}


//write command to lcd
void lcd_write_comm(uchar comm)
{
	lcd_RS_comm;
	lcd_RW_write;
	lcd_EN_write;
	NOP();
	lcd_EN_read;
	PORTB = comm;
	lcd_EN_write;
}

//write data to lcd
void lcd_write_dat(uchar dat)
{
	lcd_RS_dat;
	lcd_RW_write;
	lcd_EN_write;
	NOP();
	lcd_EN_read;
	PORTB = dat;
	lcd_EN_write;
}


//init lcd
void init_lcd(void)
{
	lcd_EN_read;
	lcd_write_comm(0x38);
	_delay_ms(1);
	lcd_write_comm(0x0c);
	_delay_ms(1);
	lcd_write_comm(0x06);
	_delay_ms(1);
	lcd_write_comm(0x01);
	_delay_ms(1);
	
}




/************************************************

	设备初始化
************************************************/


void DEVICE_init(void)
{
	cli();
    port_init();
    MCUCR = 0x00;
	USART_init();	  //UART 初始化
	sei();
}


//----------------------MAIN-----------------------
int main(void)
{
	//------设备初始化
	DEVICE_init();
//	init_lcd();
	;
	uchar i;

//const uchar txt[16];
	
 	//-----------循环-----------
 	 while(1)
	 {
	 //-----------------------------
		_delay_ms(500);	//延时500ms
		_delay_ms(500);	//延时500ms
		_delay_ms(500);	//延时500ms
		_delay_ms(500);	//延时500ms
		_delay_ms(500);	//延时500ms
		
	//	lcd_write_comm(0x80);
	//	for(i=1;i<16;i++)
	//	{
	//		lcd_write_dat(txt[i]);
	//		_delay_ms(500);
	//	}
	    USART_RX();
		LED1_XOR();
	 		
	
}
}